package dev.pfaff.altargui;

import java.util.function.BiConsumer;

/**
 * Responsible for performing layout.
 */
public interface LayoutContext extends StateContext {
	/**
	 * Lays out an element. This also "keeps alive" the element.
	 */
	void layout(WidgetInstance parent, WidgetInstance element, BiConsumer<WidgetInstance<?>, LayoutContext> layoutFunction);

	/**
	 * @see #getState(WidgetInstance, Key.CallSite, Widget)
	 * @see #layout(WidgetInstance, WidgetInstance, BiConsumer)
	 */
	default WidgetInstance layout(WidgetInstance parent, Key.CallSite callSite, Widget child, BiConsumer<WidgetInstance<?>, LayoutContext> layoutFunction) {
		var element = getState(parent, callSite, child);
		layout(parent, element, layoutFunction);
		return element;
	}
}
