package dev.pfaff.altargui.element;

import dev.pfaff.altargui.LayoutContext;
import dev.pfaff.altargui.Widget;
import dev.pfaff.altargui.WidgetInstantiationArgs;
import org.jetbrains.annotations.MustBeInvokedByOverriders;

public abstract class SingleChildWidgetInstance<W extends Widget> extends CustomLayoutSingleChildWidgetInstance<W> {
	protected SingleChildWidgetInstance(WidgetInstantiationArgs args) {
		super(args);
	}

	@Override
	@MustBeInvokedByOverriders
	protected void computeLayout(LayoutContext context) {
		context.layout(this, getChildElement(), (e, ctx) -> {
			e.copyAllocatedRectFrom(this);
			e.layout(ctx);
			copyComputedSizeFrom(e);
		});
	}
}
